#ifndef DETECT_COLLECTIVES_HPP
#define DETECT_COLLECTIVES_HPP

#include "DataFlow.hpp"

enum colltype_e {BCAST, SCATTER, GATHER, ALLTOALL, ALLGATHER};

class Collective {

	public:
		enum colltype_e colltype;
		std::vector<tuple*>* tuples;

	~Collective() {
		for (std::vector<tuple*>::iterator it=tuples->begin(); it != tuples->end(); ++it) {
			delete *it;
		}
		delete tuples;
	}
};


std::vector<tuple*>* DetectCollectives(int num_procs, std::vector<tuple*>* tuples, std::vector<Collective*>* colls);

#endif

