#ifndef cDAG_SCHEDULER_HPP
#define cDAG_SCHEDULER_HPP

#include "cDAG_Types.hpp"

typedef char* schedule_t;
struct sched_elem_t {
  char type;
  int numprev;
  int numadj;
  int *adj;
  void *args;
};

/* function prototypes */
int cDAG_Sched_run(cDAG_Handle *handle);
schedule_t NBC_Schedule_graph(cDAG_Graph graph);
int cDAG_Free_graph(cDAG_Graph graph);

/* macros */
#define SCHED_GET(addr, schedule, offset, size)               \
{                                                             \
  memcpy(addr, schedule+offset, size);                        \
  /*printf("SCHED_GET %i from offset %i\n", *addr, offset); */\
  offset += size;                                             \
}

#define SCHED_SET(addr, schedule, offset, size)               \
{                                                             \
  memcpy(schedule+offset, addr, size);                        \
  /*printf("SCHED_SET %i to offset %i\n", *addr, offset);  */ \
  offset += size;                                             \
}

#define SCHED_ADD(addr, schedule, offset, size)               \
{                                                             \
  schedule = (char*)realloc(schedule, offset+size);           \
  SCHED_SET(addr, schedule, offset, size);                    \
}

#define SCHED_ADD2(addr, schedule, offset, size, alloc_size)  \
{                                                             \
  printf("alloc size: %i\n", alloc_size);                       \
  printf("offset: %i\n", alloc_size);                       \
  printf("size: %i\n", alloc_size);                       \
  if (offset+size < alloc_size) {                             \
  	schedule = (char*)realloc(schedule, (offset+size)<<1);       \
	printf("sched_size is now %i\n", alloc_size);             \
    alloc_size = 2*(offset+size);                             \
  }                                                           \
  SCHED_SET(addr, schedule, offset, size);                    \
}



#endif
