#!/bin/bash

#PBS -l nodes=128:ppn=4,walltime=01:00:00
#PBS -q medium

cd /lustrefs/homes/timos/Work/colldetect/src/new/libcDAG/tests

for i in `seq 16 16 512`; do
	echo "doing bcast_linear with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_linear
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_linear.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done

for i in `seq 16 16 512`; do
	echo "doing bcast_linear_nocollopt with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_linear_nocollopt
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_linear_nocollopt.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done

for i in `seq 16 16 512`; do
	echo "doing bcast_binomial with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_binomial
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_binomial.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done

for i in `seq 16 16 512`; do
	echo "doing bcast_binomial_nocollopt with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_binomial_nocollopt
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_binomial_nocollopt.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done

for i in `seq 16 16 512`; do
	echo "doing bcast_linear_extra_msgs with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_linear_extra_msgs
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_linear_extra_msgs.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done

for i in `seq 16 16 512`; do
	echo "doing bcast_linear_extra_msgs_nocollopt with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_linear_extra_msgs_nocollopt
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_linear_extra_msgs_nocollopt.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done

for i in `seq 16 16 512`; do
	echo "doing bcast_binomial_extra_msgs with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_binomial_extra_msgs
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_binomial_extra_msgs.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done

for i in `seq 16 16 512`; do
	echo "doing bcast_binomial_extra_msgs_nocollopt with $i ranks" >> trace.out
	mpirun -mca btl tcp,self -np $i ./bcast_binomial_extra_msgs_nocollopt
	mpirun -mca btl tcp,self -np $i sync
	tar czf pgt.cdag_${i}_perf_bcast_binomial_extra_msgs_nocollopt.tgz  pgt.cdag_${i}_perf.r*
	rm pgt.cdag_${i}_perf.r*
done



